% simulation for bauer hamilton econometric points

redosim = 1; % 0 to fiddle with plots after one simulation, 1 to redo the simulation

if redosim
    clear all
    close all
    
    sim_case = 2; % 1: 0.95 2: 1.00
    T = 30;
    Ntrial = 20000;
    
    b1 = 0.0; % price variable used to forecast returns
    b2 = 0.0; % second variable
    
    if sim_case == 1; phi1 = 0.95;phi2 = 0.95; rho = -0.9; end;
    if sim_case == 2; phi1 = 1.0;phi2 = 1.0; rho = -0.999; end;
    
    % r = b1 x1 + b2 x2 + err
    % r x1 x2
    err_cov = [ 1 0 0;...
        0 1 0;...
        0 0 1];
    [bn, R2n] = f_dosim(T,Ntrial,err_cov,b1,b2,phi1,phi2);
    
    err_cov = [ 1  rho 0 ;...
               rho  1  0 ;...
                0   0  1];
   
    [bn_neg, R2n_neg] = f_dosim(T,Ntrial,err_cov,b1,b2,phi1,phi2);
    
    
    if 0;
        figure;
        bsort = sort(bn(:,1));
        plot(bsort,(1:Ntrial)'/Ntrial*100);
        hold on
        plot(b*[1 1]',[0 100]','-r')
    end;
    
    
    [histb,bpts] = f_makehist(bn(:,2),-0.5,1,0.01,0.05); % no correlation
    [histb_neg,bpts_neg] = f_makehist(bn_neg(:,1),-0.5,1,0.01,0.05);%stambaugh effect
    [histb_rcor,bpts_rcor] = f_makehist(bn_neg(:,2),-0.5,1,0.01,0.05);%BH effect
    
end;
    
% make plots

close all;    
figure; 
plot(bpts,histb,'linewidth',2);
hold on;
plot(bpts_neg,histb_neg,'-r','linewidth',2);
plot(bpts_rcor,histb_rcor,'-m','linewidth',2);
plot(b1*[1 1]',[0 max(histb)]','-k','linewidth',2)
legend('b_1, cov(e^x,e^y,e^r) = 0',['b_1, corr(e^x e^r) = ' num2str(rho,'%2.1f')],...
                                       ['b_2, corr(e^x e^r) = ' num2str(rho,'%2.1f')]);
xlabel('b')
if sim_case==1;
    print -depsc2 simgraph_stambaugh.eps
elseif sim_case==2
    print -depsc2 simgraph_stambaugh2.eps
end

