function [bj,sebj,R2j,bav,sebav,R2av,R2sameb,bov,sebov,R2ov]= f_doregs(r,x,xlbls,ylbls,print_flag); 
% function to do regressions in jps data
% presumes r is a set of monthly observations of annual returns
% presumes x is a conformable set of monthly forecasting variables
% syntax xlbls = {'y2'; 'f1'};

if ~(size(r,1) == size(x,1));
    disp('f_doregs: length of r and x must be the same')
end;

% do just january 
lhv = r(1:12:end,:); 
rhv = x(1:12:end,:); 

[bj,sebj,R2j,R2vadj,v,F] = olsgmm(lhv,rhv,0,0);

% printout january
if print_flag == 1;
    
    disp(' ')
    disp(' ----------------');
    disp(' ')
    disp('regressions of ')
    disp(ylbls);
    disp('on')
    disp(xlbls);
    disp(' ');
    
    disp('Just January');
    f_print(r,x,ylbls,xlbls,bj,sebj,R2j);
end;

% average of all months
Nr = size(r,2);
Nx = size(x,2);
bav = zeros(Nx,Nr);
R2av = zeros(Nr,1);
sebav = zeros(Nx,Nr); 


for indx = 0:11;
    lhv = r(1+indx:12:end,:);
    rhv = x(1+indx:12:end,:);
  
    [bv,sebv,R2v,R2vadj,v,F] = olsgmm(lhv,rhv,0,0);
    bav = bav+bv;
    sebav = sebav+sebv;
    R2av = R2av+R2v;
end;

bav = bav/12; 
sebav = sebav/12; 
R2av = R2av/12; 

% display average months

if print_flag == 1;
    disp(' ');
    disp('Average months');
    f_print(r,x,ylbls,xlbls,bav,sebav,R2av);
end;

% R2 from using same coefficient across months
varerr = 0; 
vary = 0; 
for indx = 0:11;
    lhv = r(1+indx:12:end,:);
    rhv = x(1+indx:12:end,:);
  
    err = lhv - rhv*bav;
    varerr = varerr + var(err);
    vary = vary + var(lhv);
end;
R2sameb = 1-varerr./vary; 


if print_flag == 1;
    fprintf('\n');
    fprintf('%6.6s','R2 b=');
    fprintf('%6.2f',R2sameb)
    fprintf('\n');
end;

% now do overlapping 

lhv = r; 
rhv = x; 
[bov,sebov,R2ov,R2vadj,v,F] = olsgmm(lhv,rhv,12,0);


if print_flag == 1;
    disp(' ');
    disp('Overlapping');
    f_print(r,x,ylbls,xlbls,bov,sebov,R2ov);
end;







