%f_dosim function 

% simulates 
%r = b1 x1 + b2 x2 + er
%x1 = phi1 x1 + ex1
%x2 = phi2 x2 + ex2
%
%then runs 
%
%r = b1 x1
%x1 = phi1 x1

function [bn, R2n] = f_dosim(T,Ntrial,err_cov,b1,b2,phi1,phi2)

C = chol(err_cov);
bn = zeros(Ntrial,2);
R2n = zeros(Ntrial,3); 
rng(1);% start randn at same place

for trial = 1:Ntrial;
     err = randn(T,3)*C;
     rt = zeros(T,1);
     x1t = zeros(T,1); 
     x2t = zeros(T,1); 
     for t = 2:T; 
         rt(t) = b1*x1t(t-1) + b2*x2t(t-1) + err(t,1);
         x1t(t) = phi1*x1t(t-1) + err(t,2);
         x2t(t) = phi2*x2t(t-1) + err(t,3);
     end; 
     rhv = [ones(T-1,1) x1t(1:T-1) x2t(1:T-1)];
     lhv = [rt(2:T) x1t(2:T) x2t(2:T)];
     [bv,sebv,R2v,R2vadj,v,F] = olsgmm(lhv,rhv,0,0);
    
     bn(trial,:) = bv(2:3,1)';
     R2n(trial,:) = R2v;
end;
